
import os.path, imp
import _plugins

# 
# ------------ Functions for internal use -----------------
#              (used by python-loader.so)
#

initialized = 0
has_upf_ownership = None

# Loads python code from file:
def load_plugin(filename):
    print 'upf-python: loading %s...' % filename
    dirname, filename = os.path.split(filename)
    name, ext = os.path.splitext(filename)

    fp, pathname, description = imp.find_module(name, [dirname])
    try:
        fullname = 'upf._plugins.%s' % name
        return imp.load_module(fullname, fp, pathname, description)
    finally:
        if fp:
            fp.close()


# Called by python-loader.so to tell us that UPF is already up and running
# and we don't own it:
def init_from_python_loader():
    global initialized, has_upf_ownership
    if has_upf_ownership == None:
        has_upf_ownership = 0  # make sure we don't call upf::init()
        print 'upf-python: used by non-Python UPF app'


def init_normal():
    global initialized, has_upf_ownership
    if initialized == 0:
        if has_upf_ownership == None:
            has_upf_ownership = 1
            print 'upf-python: used by Python'
        initialized = 1
